﻿using Microsoft.AspNetCore.Routing;
using System;
using System.Text.RegularExpressions;

namespace TestProject
{
    /// <summary>
    /// 커스텀 아웃 바운드 매개 변수 변환자
    /// </summary>
    public class CustomOutboundParameterTransformer : IOutboundParameterTransformer
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 아웃 바운드 변환하기 - TransformOutbound(value)

        /// <summary>
        /// 아웃 바운드 변환하기
        /// </summary>
        /// <param name="value">값</param>
        /// <returns>변환 아웃 바운드</returns>
        public string TransformOutbound(object value)
        {
            if(value == null)
            {
                return null;
            }

            return Regex.Replace
            (
                value.ToString(), 
                "([a-z])([A-Z])",
                "$1_$2",
                RegexOptions.CultureInvariant,
                TimeSpan.FromMilliseconds(100)
            ).ToLowerInvariant();
        }

        #endregion
    }
}